/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_DEVICE_OSS_H__
#define __GDAM_DEVICE_OSS_H__

typedef struct _GdamDeviceOSS GdamDeviceOSS;

#include <gdam/gdamsink.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


GtkType gdam_source_get_type();
#define GDAM_TYPE_DEVICE_OSS        (gdam_device_oss_get_type ())
#define GDAM_DEVICE_OSS(obj)        (GTK_CHECK_CAST ((obj), GDAM_TYPE_DEVICE_OSS, GdamDeviceOss))


typedef struct _GdamDeviceOss GdamDeviceOss;

struct _GdamDeviceOss {
	GdamSink		sink;
	int			device_fd;
	GPollFD			poll_fd;
	guint			source_id;
	int			fragment_size;
	void                  (*downsample_func)(void* samples, int num);
	int                     sample_size;

	/* HACK:  If your device doesn't support the `poll' system
	          call, as some drivers don't, you need to tell
		  the soundcard to use the ``fork'' option,
		  in your server.config file.

		  Currently we don't automatically do this-- instead
		  we use the following flag (has_written) + a timeout,
		  to print a verbose message describing how
		  to add the line to your config file, and then continue.

		  (ie this is a lame bug workaround)
		  (notice that even using dynamic switching, once working,
		   to fork still has problems -- it will require a
		   tradeoff between,

		   	reliability on a busy system (a theoretical
			                              concern mostly,
						      but a real problem
						      once the time is
						      near zero)
		   and
		        speed of retry, sound emission (no sound can
			                                be output while
							we are timing out
							the select)
		TODO: move this to some more useful document.
	  */
	gboolean		has_written;
};

GdamSink* gdam_device_oss_new (gpointer      device_data,
                               const char*   device_name,
			       const char*   device_options);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
